<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 IMIA net based solutions (info@imia.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

namespace IMIA\ImiaBaseExt\Annotation\TCA;

/**
 * @package     imia_base_ext
 * @subpackage  Annotation\TCA
 * @author      David Frerich <d.frerich@imia.de>
 *
 * @Annotation
 * @Target("PROPERTY")
 */
class Inline extends Column
{
    /**
     * @var array
     */
    static public $defaults = [
        'l10n_mode'  => 'exclude',
        'appearance' => [
            'collapseAll'  => true,
            'expandSingle' => true,
        ],
    ];

    /**
     * @var array
     */
    static public $fixed = [
        'type' => 'inline',
    ];

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_table;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $foreign_record_defaults;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $appearance;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $behaviour;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $customControls;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_field;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_label;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_selector;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $foreign_selector_fieldTcaOverride;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_sortby;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_default_sortby;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_table_field;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $foreign_unique;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $filter;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $MM;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $foreign_match_fields;

    /**
     * @ConfigProperty
     *
     * @var array
     */
    public $foreign_types;

    /**
     * @ConfigProperty
     *
     * @var integer
     */
    public $size;

    /**
     * @ConfigProperty
     *
     * @var integer
     */
    public $autoSizeMax;

    /**
     * @ConfigProperty
     *
     * @var integer
     */
    public $maxitems;

    /**
     * @ConfigProperty
     *
     * @var integer
     */
    public $minitems;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $symmetric_field;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $symmetric_label;

    /**
     * @ConfigProperty
     *
     * @var string
     */
    public $symmetric_sortby;
}