<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 IMIA net based solutions (info@imia.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

namespace IMIA\ImiaBaseExt\Hook;

use IMIA\ImiaBaseExt\Utility\DynamicConfiguration;
use TYPO3\CMS\Core\Database\TableConfigurationPostProcessingHookInterface;
use TYPO3\CMS\Core\Utility\ExtensionManagementUtility;

/**
 * @package     imia_base_ext
 * @subpackage  Hook
 * @author      David Frerich <d.frerich@imia.de>
 */
class TableConfigurationPostProcessing implements TableConfigurationPostProcessingHookInterface
{
    public function processData()
    {
        // Build SQL, TCA and TypoScript for all Extensions
        DynamicConfiguration::build('tables');

        // load dynConfig files
        ExtensionManagementUtility::loadNewTcaColumnsConfigFiles();

        if (array_key_exists('tx_powermail_domain_model_answer', $GLOBALS['TCA'])) {
            $GLOBALS['TCA']['tx_powermail_domain_model_answer']['ctrl']['excludeOnPageCopy'] = true;
        }

        if (array_key_exists('tx_powermail_domain_model_answers', $GLOBALS['TCA'])) {
            $GLOBALS['TCA']['tx_powermail_domain_model_answers']['ctrl']['excludeOnPageCopy'] = true;
        }

        if (array_key_exists('tx_powermail_domain_model_mail', $GLOBALS['TCA'])) {
            $GLOBALS['TCA']['tx_powermail_domain_model_mail']['ctrl']['excludeOnPageCopy'] = true;
        }

        if (array_key_exists('tx_powermail_domain_model_mails', $GLOBALS['TCA'])) {
            $GLOBALS['TCA']['tx_powermail_domain_model_mails']['ctrl']['excludeOnPageCopy'] = true;
        }

        $GLOBALS['TCA']['be_groups']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['be_users']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['sys_file']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['sys_file_metadata']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['sys_file_storage']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['sys_language']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['tx_extensionmanager_domain_model_extension']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['tx_extensionmanager_domain_model_repository']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['tx_scheduler_task_group']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['static_countries']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['static_country_zones']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['static_currencies']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['static_languages']['ctrl']['excludeOnPageCopy'] = true;
        $GLOBALS['TCA']['static_territories']['ctrl']['excludeOnPageCopy'] = true;
    }
}