<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 IMIA net based solutions (info@imia.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

namespace IMIA\ImiaBaseExt\Xclass\Install\Service;

/**
 * @package     imia_base_ext
 * @subpackage  Xclass
 * @author      David Frerich <d.frerich@imia.de>
 */
class SqlSchemaMigrationService extends \TYPO3\CMS\Install\Service\SqlSchemaMigrationService
{
    /**
     * @inheritdoc
     */
    public function getFieldDefinitions_database()
    {
        $total = parent::getFieldDefinitions_database();

        $tables = $this->getDatabaseConnection()->admin_get_tables();
        foreach ($tables as $tableName => $tableStatus) {
            if (!$tableStatus['Engine']) {
                $total[$tableName] = ['view' => true];
            }
        }

        return $total;
    }

    /**
     * @inheritdoc
     */
    public function getDatabaseExtra($FDsrc, $FDcomp, $onlyTableList = '', $ignoreNotNullWhenComparing = false)
    {
        foreach ($FDcomp as $tableName => $config) {
            if (isset($config['view']) && $config['view']) {
                unset($FDsrc[$tableName]);
            }
        }

        return parent::getDatabaseExtra($FDsrc, $FDcomp, $onlyTableList, $ignoreNotNullWhenComparing);
    }
}